{g-vars.i &vsh = "shared"}

screen-title = "Add Rooms".

def shared var current-floor-no as int.
def button btn-ok label "Add".
def button btn-cancel label "Cancel".

def var start-no as int.
def var end-no as int.
def var room-type as int.

form current-floor-no label "Enter floor no" at row 1 col 20 colon-aligned
           skip
           start-no label "First room"  at  row 2 col 20 colon-aligned validate (start-no >= 1 and start-no <= 99, "Room number is between 1 and 99")
           skip
           end-no label "Last room"  at  row 3 col 20 colon-aligned 
                  validate (end-no >= 1 and end-no <= 99, "Room number is between 1 and 99")
           skip
           room-type view-as combo-box inner-lines 5  label "Room type" at row 4 col 20 colon-aligned
           skip
           btn-ok
           btn-cancel
           with frame f1 side-labels overlay centered view-as dialog-box
                cancel-button btn-cancel default-button btn-ok.

run set-room-types-combo (input room-type:handle in frame f1).

on "choose" of btn-ok in frame f1 do:
   assign start-no end-no room-type current-floor-no.
   if start-no > end-no then do:
      message "Start number must be less than end room number" view-as alert-box.
      return.
   end.

   def var r-no as int.
   def var s-no as int.
   def var e-no as int.
   
   s-no = current-floor-no * 100 + start-no.
   e-no = current-floor-no * 100 + end-no.
   def var a as int.
   message "Adding rooms from" s-no "to" e-no.
   
   do r-no = s-no to e-no transaction:
   
      find room where room.floor = current-floor-no and room.room-number = r-no no-lock no-error.
      if avail room then do:
         status default "Skipping room " + string(r-no).
         readkey pause 1.
         next.
      end.
      
      status default "Adding room" + string(r-no).
      create room.
      room.floor = current-floor-no.
      room.room-number = r-no.
      room.type-of-room = room-type.
      
      a = a + 1.
   end.
   
   message "Added " + string(a) + " rooms".
   pause.
   
   status default.
   apply "go" to frame f1.
end.

display current-floor-no with frame f1.
enable all with frame f1.
wait-for go of frame f1.