@echo off
SETLOCAL ENABLEDELAYEDEXPANSION 
set VERBOSE=1
if "%1"=="-n" set VERBOSE=0

set appname=
set win_proj=no
set opsys=UNIX
set winsys=

:: 1. conversion inputs
:: [include-spec] *.[fhi] - default
set include_spec=*.[fhi]
:: [program-spec] *.[pPwW] - default
set program_spec=*.[pPwW]
:: [pkgroot] com.goldencode.hotel default: test.[appname]
set pkgroot=
:: [pkgrootfolder] com/goldencode/hotel
::   automated from [pkgroot] - always use "/"
set pkgrootfolder=
:: [propath]    
::   p2j.cfg.linux:   "${P2J_HOME}:${P2J_HOME}/abl"
::   p2j.cfg.windows: "${P2J_HOME};${P2J_HOME}\abl"
::   directory.xml: ".: " -> with ": " separator, from this it computes the linux/windows versions
set propath=.:
set propathsep=:
set propathcfg=

:: 2. database inputs:
:: [dbname] hotel
set dbname=
:: [dbadmin] fwd_admin
set dbadmin=
:: [dbadminpass] admin
set dbadminpass=
:: [dbuser] fwd_user
set dbuser=
:: [dbuserpass] user
set dbuserpass=
::[dmoindex] com/goldencode/hotel/dmo/dmo_index.xml [pkgrootfolder]/dmo/dmo_index.xml
::   automated...
set dmoindex=

:: 3. runtime setup 
:: [spawner-path] /opt/spawner/spawn default: $PWD/deploy/spawner/spawn
:: automated
set spawner_path=
:: [client-start-dir] /home/ca/workspace/hotel/deploy/client default: $PWD/deploy/client
:: automated
set client_start_dir=
:: [p2j-entry] com.goldencode.hotel.Login
set p2j_entry=
:: [dateFormat] mdy
set dateFormat=mdy
:: [numberGroupSep] ,
set numberGroupSep=,
:: [numberDecimalSep] .
set numberDecimalSep=.
:: [path-separator] :
set path_separator=:
:: [file-separator] /
set file_separator=/
:: [case-sensitive] TRUE
set case_sensitive=TRUE
:: [unix-escapes] TRUE
set unix_escapes=TRUE

set /p appname= "Enter your application name (only letters or digits, first character a letter): "
set pkgroot=test.%appname%

:: 1. conversion inputs
if %VERBOSE%==1 echo 1. Enter conversion configurations for your project
set /p include_spec= "Edit the regex which matches all your include files (enter for default '%include_spec%'): "
set /p program_spec= "Edit the regex which matches all your program files (enter for default '%program_spec%'): "
set /p pkgroot= "Edit the root package name - Java format (enter for default '%pkgroot%'): "
:: pkgrootfolder - automated
set /p propath= "Enter the PROPATH from your progress.ini file (enter for default '%propath%'): "

:: 2. database inputs
if %VERBOSE%==1 echo 2. Enter database configuration for your project
set /p dbname= "Enter the legacy database name: "
set /p dbadmin= "Enter the SQL admin for your imported database: "
set /p dbadminpass= "Enter the SQL admin password for your imported database: "
set /p dbuser= "Enter the SQL user for your imported database: "
set /p dbuserpass= "Enter the SQL user password for your imported database: "
:: dmoindex - automated

:: 3. runtime setup
if %VERBOSE%==1 echo 3. Enter runtime configuration for your project
set /p win_proj= "Does your ABL application currently run on the Windows OS (answer yes/no): "
set /p dateFormat= "Enter the date format from your progress.ini (enter for default '%dateFormat%'): "
set /p numberGroupSep= "Enter the number group separator from your progress.ini (enter for default '%numberGroupSep%'): "
set /p numberDecimalSep= "Enter the number decimal separator from your progress.ini (enter for default '%numberDecimalSep%'): "
set /p p2j_entry= "Enter the full class name associated with the entry point for your application: "
  
:: build automated values
set pkgrootfolder=%pkgroot:.=/%
set dmoindex=%pkgrootfolder%/dmo/dmo_index.xml
set spawner_path=%cd%\deploy\spawner\spawn.exe
set client_start_dir=%cd%\deploy\client

if "%win_proj%" equ "yes" (
   set path_separator=;
   set file_separator=\
   set case_sensitive=FALSE
   set unix_escapes=FALSE
   set propathsep=;
   set opsys=WIN32
   set winsys=^^^<parameter name="winsys"           value="MS-WINDOWS" /^^^>
)

set user=%USERNAME%

set propathcfg=${P2J_HOME}:${P2J_HOME}/abl
set propathentries=%propath%
set searchpath=.
:nextSplit
for /F "tokens=1* delims=%propathsep%" %%a in ("%propathentries%") do (
   if "%%a" neq "." (
      set pcfgpentry=%%a
      set pcfgpentry=!pcfgpentry:\=/!
      set propathcfg=%propathcfg%:${P2J_HOME}/abl/!pcfgpentry!

      set ppentry=%%a
      set ppentry=!ppentry:/=\!
      set searchpath=%searchpath%;!ppentry!
   )
   set propathentries=%%b
)
if defined propathentries goto nextSplit

SETLOCAL DISABLEDELAYEDEXPANSION 
del /f build.properties
for /f "tokens=* delims=" %%x in (build.properties.template) do (
   set b=%%x
   SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
   set b=!b:[appname]=%appname%!
   set b=!b:[program-spec]=%program_spec%!
   set b=!b:[dbname]=%dbname%!
   set b=!b:[dbuser]=%dbuser%!
   set b=!b:[dbuserpass]=%dbuserpass%!
   set b=!b:[dbadmin]=%dbadmin%!
   set b=!b:[dbadminpass]=%dbadminpass%!
   set b=!b:[pkgrootfolder]=%pkgrootfolder%!
   echo.!b!>> build.properties
   ENDLOCAL
)
ENDLOCAL

SETLOCAL DISABLEDELAYEDEXPANSION 
del /f deploy\server\directory.xml
for /f "tokens=* delims=" %%x in (deploy\server\directory.xml.template) do (
   set b=%%x
   SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
   set b=!b:[spawner-path]=%spawner_path%!
   set b=!b:[client-start-dir]=%client_start_dir%!
   set b=!b:[dmoindex]=%dmoindex%!
   set b=!b:[dbname]=%dbname%!
   set b=!b:[dateFormat]=%dateFormat%!
   set b=!b:[numberGroupSep]=%numberGroupSep%!
   set b=!b:[numberDecimalSep]=%numberDecimalSep%!
   set b=!b:[p2j-entry]=%p2j_entry%!
   set b=!b:[pkgroot]=%pkgroot%!
   set b=!b:[propath]=%propath%!
   set b=!b:[search-path]=%searchpath%!
   set b=!b:[path-separator]=%path_separator%!
   set b=!b:[file-separator]=%file_separator%!
   set b=!b:[case-sensitive]=%case_sensitive%!
   set b=!b:[dbuser]=%dbuser%!
   set b=!b:[dbuserpass]=%dbuserpass%!
   set b=!b:[dbadmin]=%dbadmin%!
   set b=!b:[dbadminpass]=%dbadminpass%!
   set b=!b:[os-user]=%user%!
   echo.!b!>> deploy\server\directory.xml
   ENDLOCAL
)
ENDLOCAL

del /f cfg\p2j.cfg.xml

SETLOCAL DISABLEDELAYEDEXPANSION 
for /f "tokens=* delims=" %%x in (cfg\p2j.cfg.xml.template) do (
   set b=%%x
   SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
   set b=!b:[propath]=%propathcfg%!
   set b=!b:[include-spec]=%include_spec%!
   set b=!b:[pkgroot]=%pkgroot%!
   set b=!b:[dbname]=%dbname%!
   set b=!b:[path-separator]=%path_separator%!
   set b=!b:[file-separator]=%file_separator%!
   set b=!b:[case-sensitive]=%case_sensitive%!
   set b=!b:[unix-escapes]=%unix_escapes%!
   set b=!b:[opsys]=%opsys%!
   set b=!b:[winsys]=%winsys%!
   echo.!b!>> cfg\p2j.cfg.xml
   ENDLOCAL
)
ENDLOCAL

echo.Class-Path: %appname%.jar> manifest\%appname%.mf

if "%appname%" neq "hotel" (
   del /f hotel.input.linux hotel.input.windows prepare_hotel.cmd ^
          prepare_hotel.sh data\hotel.df manifest\hotel.mf start_hotel_abl.sh
   rmdir /s /q data\dump\hotel
   rmdir /s /q  abldb\
   cd abl\
   rmdir /s /q * 
   cd ..
   del /f cfg\p2j.cfg.xml.template deploy\server\directory.xml.template build.properties.template
)